diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/model/eht/eht-configuration.cc ns-3.39/src/wifi/model/eht/eht-configuration.cc
--- ns-3.38/src/wifi/model/eht/eht-configuration.cc	2023-03-16 20:54:23.852869300 -0700
+++ ns-3.39/src/wifi/model/eht/eht-configuration.cc	2023-07-05 14:23:48.109428400 -0700
@@ -19,6 +19,7 @@
 
 #include "eht-configuration.h"
 
+#include "ns3/boolean.h"
 #include "ns3/log.h"
 
 namespace ns3
@@ -41,10 +42,25 @@
 TypeId
 EhtConfiguration::GetTypeId()
 {
-    static ns3::TypeId tid = ns3::TypeId("ns3::EhtConfiguration")
-                                 .SetParent<Object>()
-                                 .SetGroupName("Wifi")
-                                 .AddConstructor<EhtConfiguration>();
+    static ns3::TypeId tid =
+        ns3::TypeId("ns3::EhtConfiguration")
+            .SetParent<Object>()
+            .SetGroupName("Wifi")
+            .AddConstructor<EhtConfiguration>()
+            .AddAttribute("EmlsrActivated",
+                          "Whether EMLSR option is activated. If activated, EMLSR mode can be "
+                          "enabled on the EMLSR links by an installed EMLSR Manager.",
+                          TypeId::ATTR_GET |
+                              TypeId::ATTR_CONSTRUCT, // prevent setting after construction
+                          BooleanValue(false),
+                          MakeBooleanAccessor(&EhtConfiguration::m_emlsrActivated),
+                          MakeBooleanChecker())
+            .AddAttribute("TransitionTimeout",
+                          "The Transition Timeout (not used by non-AP MLDs). "
+                          "Possible values are 0us or 2^n us, with n=7..16.",
+                          TimeValue(MicroSeconds(0)),
+                          MakeTimeAccessor(&EhtConfiguration::m_transitionTimeout),
+                          MakeTimeChecker(MicroSeconds(0), MicroSeconds(65536)));
     return tid;
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/model/eht/eht-configuration.h ns-3.39/src/wifi/model/eht/eht-configuration.h
--- ns-3.38/src/wifi/model/eht/eht-configuration.h	2023-03-16 20:54:23.852869300 -0700
+++ ns-3.39/src/wifi/model/eht/eht-configuration.h	2023-07-05 14:23:48.109428400 -0700
@@ -20,6 +20,7 @@
 #ifndef EHT_CONFIGURATION_H
 #define EHT_CONFIGURATION_H
 
+#include "ns3/nstime.h"
 #include "ns3/object.h"
 
 namespace ns3
@@ -44,6 +45,10 @@
      * \return the object TypeId
      */
     static TypeId GetTypeId();
+
+  private:
+    bool m_emlsrActivated;    //!< whether EMLSR option is activated
+    Time m_transitionTimeout; //!< Transition timeout
 };
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/model/eht/eht-frame-exchange-manager.cc ns-3.39/src/wifi/model/eht/eht-frame-exchange-manager.cc
--- ns-3.38/src/wifi/model/eht/eht-frame-exchange-manager.cc	2023-03-16 20:54:23.856869200 -0700
+++ ns-3.39/src/wifi/model/eht/eht-frame-exchange-manager.cc	2023-07-05 14:23:48.109428400 -0700
@@ -22,7 +22,9 @@
 #include "eht-phy.h"
 
 #include "ns3/abort.h"
+#include "ns3/ap-wifi-mac.h"
 #include "ns3/log.h"
+#include "ns3/wifi-mac-queue.h"
 
 #undef NS_LOG_APPEND_CONTEXT
 #define NS_LOG_APPEND_CONTEXT std::clog << "[link=" << +m_linkId << "][mac=" << m_self << "] "
@@ -67,8 +69,8 @@
 {
     NS_LOG_FUNCTION(this << *mpdu);
 
-    // alias needs only be created for non-broadcast data frames exchanged between two MLDs
-    if (!mpdu->GetHeader().IsData() || m_mac->GetNLinks() == 1 ||
+    // alias needs only be created for non-broadcast QoS data frames exchanged between two MLDs
+    if (!mpdu->GetHeader().IsQosData() || m_mac->GetNLinks() == 1 ||
         mpdu->GetHeader().GetAddr1().IsGroup() ||
         !GetWifiRemoteStationManager()->GetMldAddress(mpdu->GetHeader().GetAddr1()))
     {
@@ -118,9 +120,147 @@
         txVector.SetSigBMode(sigBMode);
     }
 
+    if (!m_apMac)
+    {
+        HeFrameExchangeManager::ForwardPsduDown(psdu, txVector);
+        return;
+    }
+
+    auto txDuration = WifiPhy::CalculateTxDuration(psdu, txVector, m_phy->GetPhyBand());
+
+    // check if the EMLSR clients shall switch back to listening operation at the end of this PPDU
+    for (auto clientIt = m_protectedStas.begin(); clientIt != m_protectedStas.end();)
+    {
+        auto aid = GetWifiRemoteStationManager()->GetAssociationId(*clientIt);
+
+        if (GetWifiRemoteStationManager()->GetEmlsrEnabled(*clientIt) &&
+            GetEmlsrSwitchToListening(psdu, aid, *clientIt))
+        {
+            EmlsrSwitchToListening(*clientIt, txDuration);
+            // this client is no longer involved in the current TXOP
+            clientIt = m_protectedStas.erase(clientIt);
+        }
+        else
+        {
+            clientIt++;
+        }
+    }
+
     HeFrameExchangeManager::ForwardPsduDown(psdu, txVector);
 }
 
+void
+EhtFrameExchangeManager::ForwardPsduMapDown(WifiConstPsduMap psduMap, WifiTxVector& txVector)
+{
+    NS_LOG_FUNCTION(this << psduMap << txVector);
+
+    if (!m_apMac)
+    {
+        HeFrameExchangeManager::ForwardPsduMapDown(psduMap, txVector);
+        return;
+    }
+
+    auto txDuration = WifiPhy::CalculateTxDuration(psduMap, txVector, m_phy->GetPhyBand());
+
+    // check if the EMLSR clients shall switch back to listening operation at the end of this PPDU
+    for (auto clientIt = m_protectedStas.begin(); clientIt != m_protectedStas.end();)
+    {
+        auto aid = GetWifiRemoteStationManager()->GetAssociationId(*clientIt);
+
+        if (auto psduMapIt = psduMap.find(aid);
+            GetWifiRemoteStationManager()->GetEmlsrEnabled(*clientIt) &&
+            (psduMapIt == psduMap.cend() ||
+             GetEmlsrSwitchToListening(psduMapIt->second, aid, *clientIt)))
+        {
+            EmlsrSwitchToListening(*clientIt, txDuration);
+            // this client is no longer involved in the current TXOP
+            clientIt = m_protectedStas.erase(clientIt);
+        }
+        else
+        {
+            clientIt++;
+        }
+    }
+
+    HeFrameExchangeManager::ForwardPsduMapDown(psduMap, txVector);
+}
+
+void
+EhtFrameExchangeManager::EmlsrSwitchToListening(const Mac48Address& address, const Time& delay)
+{
+    NS_LOG_FUNCTION(this << address << delay.As(Time::US));
+
+    // this EMLSR client switches back to listening operation a transition delay
+    // after the given delay
+    auto mldAddress = GetWifiRemoteStationManager()->GetMldAddress(address);
+    NS_ASSERT(mldAddress);
+    auto emlCapabilities = GetWifiRemoteStationManager()->GetStationEmlCapabilities(address);
+    NS_ASSERT(emlCapabilities);
+
+    for (uint8_t linkId = 0; linkId < m_mac->GetNLinks(); linkId++)
+    {
+        if (m_mac->GetWifiRemoteStationManager(linkId)->GetEmlsrEnabled(*mldAddress))
+        {
+            Simulator::Schedule(delay, [=]() {
+                if (linkId != m_linkId)
+                {
+                    // the reason for blocking the other EMLSR links has changed now
+                    m_mac->UnblockUnicastTxOnLinks(WifiQueueBlockedReason::USING_OTHER_EMLSR_LINK,
+                                                   *mldAddress,
+                                                   {linkId});
+                }
+
+                // block DL transmissions on this link until transition delay elapses
+                m_mac->BlockUnicastTxOnLinks(WifiQueueBlockedReason::WAITING_EMLSR_TRANSITION_DELAY,
+                                             *mldAddress,
+                                             {linkId});
+            });
+
+            // unblock all EMLSR links when the transition delay elapses
+            Simulator::Schedule(delay + CommonInfoBasicMle::DecodeEmlsrTransitionDelay(
+                                            emlCapabilities->emlsrTransitionDelay),
+                                [=]() {
+                                    m_mac->UnblockUnicastTxOnLinks(
+                                        WifiQueueBlockedReason::WAITING_EMLSR_TRANSITION_DELAY,
+                                        *mldAddress,
+                                        {linkId});
+                                });
+        }
+    }
+}
+
+void
+EhtFrameExchangeManager::SendEmlOperatingModeNotification(
+    const Mac48Address& dest,
+    const MgtEmlOperatingModeNotification& frame)
+{
+    NS_LOG_FUNCTION(this << dest << frame);
+
+    WifiMacHeader hdr;
+    hdr.SetType(WIFI_MAC_MGT_ACTION);
+    hdr.SetAddr1(dest);
+    hdr.SetAddr2(m_self);
+    hdr.SetAddr3(m_bssid);
+    hdr.SetDsNotTo();
+    hdr.SetDsNotFrom();
+
+    // get the sequence number for the TWT Setup management frame
+    const auto sequence = m_txMiddle->GetNextSequenceNumberFor(&hdr);
+    hdr.SetSequenceNumber(sequence);
+
+    WifiActionHeader actionHdr;
+    WifiActionHeader::ActionValue action;
+    action.protectedEhtAction = WifiActionHeader::PROTECTED_EHT_EML_OPERATING_MODE_NOTIFICATION;
+    actionHdr.SetAction(WifiActionHeader::PROTECTED_EHT, action);
+
+    auto packet = Create<Packet>();
+    packet->AddHeader(frame);
+    packet->AddHeader(actionHdr);
+
+    // Use AC_VO to send management frame addressed to a QoS STA (Sec. 10.2.3.2 of 802.11-2020)
+    m_mac->GetQosTxop(AC_VO)->Queue(Create<WifiMpdu>(packet, hdr));
+}
+
 std::optional<double>
 EhtFrameExchangeManager::GetMostRecentRssi(const Mac48Address& address) const
 {
@@ -154,4 +294,141 @@
     return std::nullopt;
 }
 
+void
+EhtFrameExchangeManager::SendMuRts(const WifiTxParameters& txParams)
+{
+    NS_LOG_FUNCTION(this << &txParams);
+
+    uint8_t maxPaddingDelay = 0;
+
+    // block transmissions on the other EMLSR links of the EMLSR clients
+    for (const auto& address : m_sentRtsTo)
+    {
+        if (!GetWifiRemoteStationManager()->GetEmlsrEnabled(address))
+        {
+            continue;
+        }
+
+        auto emlCapabilities = GetWifiRemoteStationManager()->GetStationEmlCapabilities(address);
+        NS_ASSERT(emlCapabilities);
+        maxPaddingDelay = std::max(maxPaddingDelay, emlCapabilities->emlsrPaddingDelay);
+
+        auto mldAddress = GetWifiRemoteStationManager()->GetMldAddress(address);
+        NS_ASSERT(mldAddress);
+
+        for (uint8_t linkId = 0; linkId < m_apMac->GetNLinks(); linkId++)
+        {
+            if (linkId != m_linkId &&
+                m_mac->GetWifiRemoteStationManager(linkId)->GetEmlsrEnabled(*mldAddress))
+            {
+                m_mac->BlockUnicastTxOnLinks(WifiQueueBlockedReason::USING_OTHER_EMLSR_LINK,
+                                             *mldAddress,
+                                             {linkId});
+            }
+        }
+    }
+
+    // add padding (if needed)
+    if (maxPaddingDelay > 0)
+    {
+        NS_ASSERT(txParams.m_protection &&
+                  txParams.m_protection->method == WifiProtection::MU_RTS_CTS);
+        WifiMuRtsCtsProtection* protection =
+            static_cast<WifiMuRtsCtsProtection*>(txParams.m_protection.get());
+        NS_ASSERT(protection->muRts.IsMuRts());
+
+        // see formula (35-1) in Sec. 35.5.2.2.3 of 802.11be D3.0
+        auto rate = protection->muRtsTxVector.GetMode().GetDataRate(protection->muRtsTxVector);
+        std::size_t nDbps = rate / 1e6 * 4; // see Table 17-4 of 802.11-2020
+        protection->muRts.SetPaddingSize((1 << (maxPaddingDelay + 2)) * nDbps / 8);
+    }
+
+    HeFrameExchangeManager::SendMuRts(txParams);
+}
+
+bool
+EhtFrameExchangeManager::GetEmlsrSwitchToListening(Ptr<const WifiPsdu> psdu,
+                                                   uint16_t aid,
+                                                   const Mac48Address& address) const
+{
+    NS_LOG_FUNCTION(this << psdu << aid << address);
+
+    // Sec. 35.3.17 of 802.11be D3.0:
+    // The non-AP MLD shall be switched back to the listening operation on the EMLSR links after
+    // the EMLSR transition delay time if [...] the non-AP STA affiliated with the non-AP MLD
+    // does not detect [...] any of the following frames:
+    // - an individually addressed frame with the RA equal to the MAC address of the non-AP STA
+    // affiliated with the non-AP MLD
+    if (psdu->GetAddr1() == address)
+    {
+        return false;
+    }
+
+    // - a Trigger frame that has one of the User Info fields addressed to the non-AP STA
+    // affiliated with the non-AP MLD
+    for (const auto& mpdu : *PeekPointer(psdu))
+    {
+        if (mpdu->GetHeader().IsTrigger())
+        {
+            CtrlTriggerHeader trigger;
+            mpdu->GetPacket()->PeekHeader(trigger);
+            if (trigger.FindUserInfoWithAid(aid) != trigger.end())
+            {
+                return false;
+            }
+        }
+    }
+
+    // - a CTS-to-self frame with the RA equal to the MAC address of the AP affiliated with
+    // the AP MLD
+    if (psdu->GetHeader(0).IsCts())
+    {
+        if (m_apMac && psdu->GetAddr1() == m_self)
+        {
+            return false;
+        }
+        if (m_staMac && psdu->GetAddr1() == m_bssid)
+        {
+            return false;
+        }
+    }
+
+    // - a Multi-STA BlockAck frame that has one of the Per AID TID Info fields addressed to
+    // the non-AP STA affiliated with the non-AP MLD
+    if (psdu->GetHeader(0).IsBlockAck())
+    {
+        CtrlBAckResponseHeader blockAck;
+        psdu->GetPayload(0)->PeekHeader(blockAck);
+        if (blockAck.IsMultiSta() && !blockAck.FindPerAidTidInfoWithAid(aid).empty())
+        {
+            return false;
+        }
+    }
+
+    // - a NDP Announcement frame that has one of the STA Info fields addressed to the non-AP
+    // STA affiliated with the non-AP MLD and a sounding NDP
+    // TODO NDP Announcement frame not supported yet
+
+    return true;
+}
+
+void
+EhtFrameExchangeManager::NotifyChannelReleased(Ptr<Txop> txop)
+{
+    NS_LOG_FUNCTION(this << txop);
+
+    // the channel has been released; all EMLSR clients will switch back to listening
+    // operation after a timeout interval of aSIFSTime + aSlotTime + aRxPHYStartDelay
+    auto delay = m_phy->GetSifs() + m_phy->GetSlot() + MicroSeconds(20);
+    for (const auto& address : m_protectedStas)
+    {
+        if (GetWifiRemoteStationManager()->GetEmlsrEnabled(address))
+        {
+            EmlsrSwitchToListening(address, delay);
+        }
+    }
+
+    HeFrameExchangeManager::NotifyChannelReleased(txop);
+}
+
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/model/eht/eht-frame-exchange-manager.h ns-3.39/src/wifi/model/eht/eht-frame-exchange-manager.h
--- ns-3.38/src/wifi/model/eht/eht-frame-exchange-manager.h	2023-03-16 20:54:23.856869200 -0700
+++ ns-3.39/src/wifi/model/eht/eht-frame-exchange-manager.h	2023-07-05 14:23:48.109428400 -0700
@@ -21,6 +21,7 @@
 #define EHT_FRAME_EXCHANGE_MANAGER_H
 
 #include "ns3/he-frame-exchange-manager.h"
+#include "ns3/mgt-headers.h"
 
 namespace ns3
 {
@@ -46,6 +47,15 @@
     Ptr<WifiMpdu> CreateAliasIfNeeded(Ptr<WifiMpdu> mpdu) const override;
 
     /**
+     * Send an EML Operating Mode Notification frame to the given station.
+     *
+     * \param dest the MAC address of the receiver
+     * \param frame the EML Operating Mode Notification frame to send
+     */
+    void SendEmlOperatingModeNotification(const Mac48Address& dest,
+                                          const MgtEmlOperatingModeNotification& frame);
+
+    /**
      * Get the RSSI (in dBm) of the most recent packet received from the station having
      * the given address. If there is no such information for the given station and the
      * station is affiliated with an MLD, return the RSSI (in dBm) of the most recent
@@ -56,8 +66,34 @@
      */
     std::optional<double> GetMostRecentRssi(const Mac48Address& address) const override;
 
+    /**
+     * \param psdu the given PSDU
+     * \param aid the AID of an EMLSR client
+     * \param address the link MAC address of an EMLSR client
+     * \return whether the EMLSR client having the given AID and MAC address shall switch back to
+     *         the listening operation when receiving the given PSDU
+     */
+    bool GetEmlsrSwitchToListening(Ptr<const WifiPsdu> psdu,
+                                   uint16_t aid,
+                                   const Mac48Address& address) const;
+
   protected:
     void ForwardPsduDown(Ptr<const WifiPsdu> psdu, WifiTxVector& txVector) override;
+    void ForwardPsduMapDown(WifiConstPsduMap psduMap, WifiTxVector& txVector) override;
+    void SendMuRts(const WifiTxParameters& txParams) override;
+    void NotifyChannelReleased(Ptr<Txop> txop) override;
+
+    /**
+     * This method is intended to be called when an AP MLD detects that an EMLSR client previously
+     * involved in the current TXOP will start waiting for the transition delay interval (to switch
+     * back to listening operation) after the given delay.
+     * This method blocks the transmissions on all the EMLSR links of the given EMLSR client until
+     * the transition delay advertised by the EMLSR client expires.
+     *
+     * \param address the link MAC address of the given EMLSR client
+     * \param delay the given delay
+     */
+    void EmlsrSwitchToListening(const Mac48Address& address, const Time& delay);
 };
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/model/eht/eht-operation.cc ns-3.39/src/wifi/model/eht/eht-operation.cc
--- ns-3.38/src/wifi/model/eht/eht-operation.cc	2023-03-16 20:54:23.856869200 -0700
+++ ns-3.39/src/wifi/model/eht/eht-operation.cc	2023-07-05 14:23:48.109428400 -0700
@@ -1,4 +1,3 @@
-/* -*-  Mode: C++; c-file-style: "gnu"; indent-tabs-mode:nil; -*- */
 /*
  * Copyright (c) 2022
  *
@@ -28,6 +27,33 @@
 {
 
 void
+EhtOperation::Print(std::ostream& os) const
+{
+    os << "EHT Operation=" << +m_params.opInfoPresent << "|" << +m_params.disabledSubchBmPresent
+       << "|" << +m_params.defaultPeDur << "|" << +m_params.grpBuIndLimit << "|"
+       << +m_params.grpBuExp << "|[";
+    for (const auto& maxRxNss : m_mcsNssSet.maxRxNss)
+    {
+        os << +maxRxNss << "|";
+    }
+    os << "]|[";
+    for (const auto& maxTxNss : m_mcsNssSet.maxTxNss)
+    {
+        os << +maxTxNss << "|";
+    }
+    os << "]";
+    if (m_opInfo.has_value())
+    {
+        os << "|" << +m_opInfo->control.channelWidth << "|" << +m_opInfo->ccfs0 << "|"
+           << +m_opInfo->ccfs1;
+        if (m_opInfo->disabledSubchBm.has_value())
+        {
+            os << "|" << m_opInfo->disabledSubchBm.value();
+        }
+    }
+}
+
+void
 EhtOperation::EhtOpParams::Serialize(Buffer::Iterator& start) const
 {
     uint8_t val = opInfoPresent | (disabledSubchBmPresent << 1) | (defaultPeDur << 2) |
@@ -260,34 +286,4 @@
                                              << +count << ")");
     return length;
 }
-
-std::ostream&
-operator<<(std::ostream& os, const EhtOperation& ehtOperation)
-{
-    os << +ehtOperation.m_params.opInfoPresent << "|"
-       << +ehtOperation.m_params.disabledSubchBmPresent << "|"
-       << +ehtOperation.m_params.defaultPeDur << "|" << +ehtOperation.m_params.grpBuIndLimit << "|"
-       << +ehtOperation.m_params.grpBuExp << "|[";
-    for (const auto& maxRxNss : ehtOperation.m_mcsNssSet.maxRxNss)
-    {
-        os << +maxRxNss << "|";
-    }
-    os << "]|[";
-    for (const auto& maxTxNss : ehtOperation.m_mcsNssSet.maxTxNss)
-    {
-        os << +maxTxNss << "|";
-    }
-    os << "]";
-    if (ehtOperation.m_opInfo.has_value())
-    {
-        os << "|" << +ehtOperation.m_opInfo->control.channelWidth << "|"
-           << +ehtOperation.m_opInfo->ccfs0 << "|" << +ehtOperation.m_opInfo->ccfs1;
-        if (ehtOperation.m_opInfo->disabledSubchBm.has_value())
-        {
-            os << "|" << ehtOperation.m_opInfo->disabledSubchBm.value();
-        }
-    }
-    return os;
-}
-
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/model/eht/eht-operation.h ns-3.39/src/wifi/model/eht/eht-operation.h
--- ns-3.38/src/wifi/model/eht/eht-operation.h	2023-03-16 20:54:23.856869200 -0700
+++ ns-3.39/src/wifi/model/eht/eht-operation.h	2023-07-05 14:23:48.109428400 -0700
@@ -1,4 +1,3 @@
-/* -*-  Mode: C++; c-file-style: "gnu"; indent-tabs-mode:nil; -*- */
 /*
  * Copyright (c) 2022
  *
@@ -161,6 +160,7 @@
     EhtOperation();
     WifiInformationElementId ElementId() const override;
     WifiInformationElementId ElementIdExt() const override;
+    void Print(std::ostream& os) const override;
 
     /**
      * Set the max Rx NSS for input MCS index range
@@ -187,16 +187,6 @@
     uint16_t DeserializeInformationField(Buffer::Iterator start, uint16_t length) override;
 };
 
-/**
- * output stream output operator
- *
- * \param os output stream
- * \param ehtOperation the EHT operation
- *
- * \returns output stream
- */
-std::ostream& operator<<(std::ostream& os, const EhtOperation& ehtOperation);
-
 } // namespace ns3
 
 #endif /* EHT_OPERATION_H */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/model/eht/eht-phy.cc ns-3.39/src/wifi/model/eht/eht-phy.cc
--- ns-3.38/src/wifi/model/eht/eht-phy.cc	2023-03-16 20:54:23.856869200 -0700
+++ ns-3.39/src/wifi/model/eht/eht-phy.cc	2023-07-05 14:23:48.109428400 -0700
@@ -129,6 +129,20 @@
     }
 }
 
+uint32_t
+EhtPhy::GetSigBSize(const WifiTxVector& txVector) const
+{
+    if (ns3::IsDlMu(txVector.GetPreambleType()) && ns3::IsEht(txVector.GetPreambleType()))
+    {
+        return EhtPpdu::GetEhtSigFieldSize(
+            txVector.GetChannelWidth(),
+            txVector.GetRuAllocation(
+                m_wifiPhy ? m_wifiPhy->GetOperatingChannel().GetPrimaryChannelIndex(20) : 0),
+            txVector.GetEhtPpduType());
+    }
+    return HePhy::GetSigBSize(txVector);
+}
+
 Time
 EhtPhy::CalculateNonOfdmaDurationForHeTb(const WifiTxVector& txVector) const
 {
@@ -160,10 +174,8 @@
     NS_LOG_FUNCTION(this << psdus << txVector << ppduDuration);
     return Create<EhtPpdu>(psdus,
                            txVector,
-                           m_wifiPhy->GetOperatingChannel().GetPrimaryChannelCenterFrequency(
-                               txVector.GetChannelWidth()),
+                           m_wifiPhy->GetOperatingChannel(),
                            ppduDuration,
-                           m_wifiPhy->GetPhyBand(),
                            ObtainNextUid(txVector),
                            HePpdu::PSD_NON_HE_PORTION);
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/model/eht/eht-phy.h ns-3.39/src/wifi/model/eht/eht-phy.h
--- ns-3.38/src/wifi/model/eht/eht-phy.h	2023-03-16 20:54:23.856869200 -0700
+++ ns-3.39/src/wifi/model/eht/eht-phy.h	2023-07-05 14:23:48.109428400 -0700
@@ -262,6 +262,7 @@
     WifiPhyRxfailureReason GetFailureReason(WifiPpduField field) const override;
     Time CalculateNonOfdmaDurationForHeTb(const WifiTxVector& txVector) const override;
     Time CalculateNonOfdmaDurationForHeMu(const WifiTxVector& txVector) const override;
+    uint32_t GetSigBSize(const WifiTxVector& txVector) const override;
 
     /**
      * Create and return the EHT MCS corresponding to
